proyectos_django/sena/sena/urls.py
from django.contrib import admin
from django.urls import path, include

from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('tienda.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

proyectos_django/sena/tienda/urls.py
from django.urls import path, include
from rest_framework.routers import DefaultRouter
from rest_framework.documentation import include_docs_urls

from . import views

router = DefaultRouter()
router.register(r'categoria', views.CategoriaViewSet)
router.register(r'producto', views.ProductoViewSet)
router.register(r'usuario', views.UsuarioViewSet)
router.register(r'venta', views.VentaViewSet)
router.register(r'ventadetalle', views.DetalleVentaViewSet)

app_name = "tienda"

urlpatterns = [
    # URLs para las api del proyecto
	path("api/1.0/", include(router.urls)),
	# path('api/1.0/docs/', include_docs_urls(title='Inventario API')),
 
    path("inicio/<str:abrir_off_canvas>/", views.index, name="index"),
    path("", views.login, name="login"),
    path("logout/", views.logout, name="logout"),

    path("listar_categorias/", views.categorias, name="listar_categorias"),
    path("form_cat/", views.categorias_crear_formulario, name="form_cat"),
    path("categorias_guardar/", views.categorias_guardar, name="categorias_guardar"),
    path("form_edit_cat/<int:id>/", views.categorias_editar_formulario, name="form_edit_cat"),
    path("categorias_eliminar/<int:id>/", views.categorias_eliminar, name="categorias_eliminar"),
    path("cat_buscar/", views.cat_buscar, name="cat_buscar"),

    path("productos/", views.productos, name="productos"),
    path("form_pro/", views.productos_formulario, name="form_pro"),
    path("productos_guardar/", views.productos_guardar, name="productos_guardar"),
    path("productos_eliminar/<int:id>/", views.productos_eliminar, name="productos_eliminar"),
    path("form_edit_pro/<int:id>/", views.productos_editar_formulario, name="form_edit_pro"),
    path("pro_buscar/", views.pro_buscar, name="pro_buscar"),

    path("cambiar_clave/<str:actual>", views.cambiar_clave, name="cambiar_clave"),
    path("guarda_clave/", views.guarda_clave, name="guarda_clave"),
    path("perfil/", views.ver_perfil, name="perfil"),

    # Carrito de compra...
    path("carrito_agregar/", views.carrito_agregar, name="carrito_agregar"),
    path("carrito_listar/", views.carrito_listar, name="carrito_listar"),
    path("carrito_eliminar_producto/<int:id>", views.carrito_eliminar_producto, name="carrito_eliminar_producto"),
    path("carrito_actualizar/", views.carrito_actualizar, name="carrito_actualizar"),
    path("establecer_venta/", views.establecer_venta, name="establecer_venta"),

    # envio de correo
    path("correo/", views.correo, name="correo"),

    # reportes
    path("reporte1_ventas/", views.reporte1_ventas, name="reporte1_ventas"),

]

proyectos_django/sena/tienda/models.py
from django.db import models

# Create your models here.
class Categoria(models.Model):
	nombre = models.CharField(max_length=50)
	descripcion = models.TextField(null=True, blank=True)

	def __str__(self):
		return f"{self.id} ----- {self.nombre}"

class Producto(models.Model):
	nombre = models.CharField(max_length=254)
	precio = models.IntegerField()
	fecha_compra = models.DateField()
	categoria = models.ForeignKey(Categoria, on_delete=models.DO_NOTHING)
	stock = models.IntegerField(default=1)
	foto = models.ImageField(null=True, blank=True, default='fotos_productos/default.png', upload_to='fotos_productos')

	def __str__(self):
		return f"{self.id} ----- {self.nombre} ${self.precio}"


class Usuario(models.Model):
	ROLES = (
		(1, 'Administrador'),
		(2, 'WebMaster'),
		(3, 'Usuario'),
	)
	foto = models.ImageField(null=True, blank=True, default='fotos/default.png', upload_to='fotos')
	nombre = models.CharField(max_length=50)
	apellido = models.CharField(max_length=50)
	nick = models.CharField(max_length=50)
	passwd = models.CharField(max_length=254)
	rol = models.IntegerField(choices=ROLES, default=3)

	def __str__(self):
		return f"{self.nick}"


class Venta(models.Model):
	fecha_venta = models.DateTimeField(auto_now=True)
	usuario = models.ForeignKey(Usuario, on_delete=models.DO_NOTHING)
	ESTADOS = (
		(1, 'Pendiente'),
		(2, 'Enviado'),
		(3, 'Rechazada'),
	)
	estado = models.IntegerField(choices=ESTADOS, default=1)

	def __str__(self):
		return f"{self.id}"

class DetalleVenta(models.Model):
	venta = models.ForeignKey(Venta, on_delete=models.DO_NOTHING)
	producto = models.ForeignKey(Producto, on_delete=models.DO_NOTHING)
	cantidad = models.IntegerField()
	precio_historico = models.IntegerField()

	def __str__(self):
		return f"{self.id} - {self.venta}"

proyectos_django/sena/tienda/views.py
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import render, redirect
from django.urls import reverse

# Para tomar el from desde el settings
from django.conf import settings
from django.core.mail import BadHeaderError, EmailMessage

from django.db import IntegrityError, transaction

from django.db.models import Q
from django.contrib import messages
from .models import *

import os
from django.conf import settings
from django.conf.urls.static import static
import datetime
from .serializers import *
from rest_framework import viewsets

# Create your views here.


def login(request):
	if request.method == "POST":

		usuario = request.POST.get("nick")
		clave = request.POST.get("passwd")

		try:
			q = Usuario.objects.get(nick=usuario, passwd=clave)
			messages.success(request, "Bienvenido!!")
			# guardar nombre del rol y no su número...
			datos = {
				"rol": q.rol,
				"nombre_rol": q.get_rol_display(),
				"nombre": f"{q.nombre} {q.apellido}",
				"foto": q.foto.url if q.foto else "/media/fotos/default.png",
				"id": q.id
			}
			request.session["logueo"] = datos
			# variables del carrito de compra
			request.session["carrito"] = []
			request.session["cantidad_productos"] = 0
			# fin - variables del carrito de compra
			return HttpResponseRedirect(reverse("tienda:index", args=('no',)))

		except Usuario.DoesNotExist:
			messages.error(request, "Usuario o contraseña no válidos...")
			return render(request, "tienda/login.html")
	else:
		if request.session.get("logueo", False):
			return HttpResponseRedirect(reverse("tienda:index", args=('no',)))
		else:
			return render(request, "tienda/login.html")


def logout(request):
	try:
		del request.session["logueo"]
		del request.session["carrito"]
		del request.session["cantidad_productos"]
		messages.success(request, "Sesión cerrada correctamente!")
	except Exception as e:
		messages.error(request, f"Error: {e}")
	return HttpResponseRedirect(reverse("tienda:login"))


def index(request, abrir_off_canvas="no"):
	if abrir_off_canvas == "si":
		print("SI")
	else:
		print("NO")

	if request.session.get("logueo", False):
		c = Categoria.objects.all()

		# Detectar si viene paramétro id categoría para filtrar o no...
		filtro_categoria = request.GET.get("id")

		if filtro_categoria != None and filtro_categoria != '0':
			p = Producto.objects.filter(categoria_id = filtro_categoria)
			request.session["submenu"] = int(filtro_categoria)
		else:
			p = Producto.objects.all()
			request.session["submenu"] = 0

		contexto = {"categorias": c, "productos": p}
		return render(request, "tienda/index.html", contexto)
	else:
		return HttpResponseRedirect(reverse("tienda:login"))


def categorias(request):
	sesion = request.session.get("logueo", False)

	if sesion["nombre_rol"] != "Usuario":
		result = Categoria.objects.all()
		context = {"data": result}
		return render(request, "tienda/categorias/listar.html", context)
	else:
		messages.warning(request, "Usted no tiene permiso para acceder...")
		return HttpResponseRedirect(reverse("tienda:index", args=('no',)))

def categorias_crear_formulario(request):
	return render(request, "tienda/categorias/cat-form.html")


def categorias_guardar(request):
	if request.method == "POST":
		id = request.POST.get("id")
		nomb = request.POST.get("nombre")
		desc = request.POST.get("descripcion")

		if id == "":
			# crear
			try:
				cat = Categoria(
					nombre=nomb,
					descripcion=desc
				)
				cat.save()
				messages.success(request, "Guardado correctamente!!")
			except Exception as e:
				messages.error(request, f"Error. {e}")
		else:
			# actualizar
			try:
				q = Categoria.objects.get(pk=id)
				q.nombre = nomb
				q.descripcion = desc
				q.save()
				messages.success(request, "Actualizado correctamente!!")
			except Exception as e:
				messages.error(request, f"Error. {e}")

		return HttpResponseRedirect(reverse("tienda:listar_categorias", args=()))
	else:
		messages.warning(request, "No se enviaron datos...")
		return HttpResponseRedirect(reverse("tienda:form_cat", args=()))


def categorias_editar_formulario(request, id):
	q = Categoria.objects.get(pk=id)
	contexto = {"id": id, "data": q}
	return render(request, "tienda/categorias/cat-form.html", contexto)


def categorias_eliminar(request, id):
	try:
		q = Categoria.objects.get(pk=id)
		q.delete()
		messages.success(request, "Registro eliminado correctamente!!")
	except Exception as e:
		messages.error(request, f"Error: {e}")

	return HttpResponseRedirect(reverse("tienda:listar_categorias", args=()))


def cat_buscar(request):
	if request.method == "POST":

		buscar = request.POST.get("buscar")

		query = Categoria.objects.filter(
			Q(nombre__istartswith=buscar) |
			Q(descripcion__istartswith=buscar)
		)
		context = {"data": query, "buscado": buscar}
		return render(request, "tienda/categorias/listar.html", context)
	else:
		messages.warning(request, "No se enviaron datos...")
	return HttpResponseRedirect(reverse("tienda:listar_categorias", args=()))


def productos(request):
	registros = Producto.objects.all()
	contexto = {"data": registros}
	return render(request, "tienda/productos/listar.html", contexto)

def productos_formulario(request):
	query = Categoria.objects.all()
	contexto = {"categorias": query}
	return render(request, "tienda/productos/pro-form.html", contexto)


def upload_file(f, nuevo_nombre):
	with open(f"uploads/fotos_productos/{nuevo_nombre}", "wb+") as destination:
		for chunk in f.chunks():
			destination.write(chunk)


def productos_guardar(request):
	if request.method == "POST":
		foto = request.FILES.get("foto")
		if foto is not None:
			ahora = datetime.datetime.now()
			# Cambio fecha_hora ejemplo:	2024-03-18 15:28:27.109401
			# Por un string sin caracteres:	20240318_152827_109401
			ahora = str(ahora).replace("-", "").replace(" ", "_").replace(":", "").replace(".", "_")
			# Buscar la última aparición del punto para separar nombre de la extensión
			nombre_foto = foto.name.rsplit('.', 1)
			# Concateno: nombre + fecha_hora + extensión
			nuevo_nombre = f"{nombre_foto[0]}_{ahora}.{nombre_foto[1]}"
			# Envío a la función el objeto foto y el string del nuevo nombre para renombrar...
			upload_file(foto, nuevo_nombre)
		else:
			# Si no viene foto, uso la foto por defecto....
			nuevo_nombre = "default.png"

		id = request.POST.get("id")
		nomb = request.POST.get("nombre")
		precio = request.POST.get("precio")
		fecha_c = request.POST.get("fecha_compra")

		# foráneas, deben ser instancias de su clase
		cat = Categoria.objects.get(pk=request.POST.get("categoria"))

		if id == "":
			# crear
			try:
				pro = Producto(
					nombre=nomb,
					precio=precio,
					fecha_compra=fecha_c,
					categoria=cat,
					foto=f"fotos_productos/{nuevo_nombre}"
				)
				pro.save()
				messages.success(request, "Guardado correctamente!!")
			except Exception as e:
				messages.error(request, f"Error. {e}")
		else:
			# actualizar
			try:
				q = Producto.objects.get(pk=id)
				q.nombre = nomb
				q.precio = precio
				q.fecha_compra = fecha_c
				q.categoria = cat
				q.save()
				messages.success(request, "Actualizado correctamente!!")
			except Exception as e:
				messages.error(request, f"Error. {e}")

		return HttpResponseRedirect(reverse("tienda:productos", args=()))
	else:
		messages.warning(request, "No se enviaron datos...")
		return HttpResponseRedirect(reverse("tienda:form_pro", args=()))


def productos_eliminar(request, id):
	try:
		q = Producto.objects.get(pk=id)
		q.delete()

		print(f"======{settings.MEDIA_ROOT}/{q.foto}")
		if os.path.exists(f"{settings.MEDIA_ROOT}/{q.foto}"):

			if q.foto.url != "fotos_productos/default.png":
				os.remove(f"{settings.MEDIA_ROOT}/{q.foto}")
		else:
			messages.warning(request, "No existe la foto....")
		messages.success(request, "Registro eliminado correctamente!!")
	except Exception as e:
		messages.error(request, f"Error: {e}")

	return HttpResponseRedirect(reverse("tienda:productos", args=()))


def productos_editar_formulario(request, id):
	q = Producto.objects.get(pk=id)
	query = Categoria.objects.all()
	contexto = {"id": id, "data": q, "categorias": query}

	return render(request, "tienda/productos/pro-form.html", contexto)

def pro_buscar(request):
	if request.method == "POST":

		buscar = request.POST.get("buscar")

		query = Producto.objects.filter(nombre__icontains=buscar)

		context = {"data": query, "buscado": buscar}
		return render(request, "tienda/productos/listar.html", context)
	else:
		messages.warning(request, "No se enviaron datos...")
	return HttpResponseRedirect(reverse("tienda:productos", args=()))


def cambiar_clave(request, actual):
	contexto = {"actual": actual}
	return render(request, "tienda/usuarios/cambio_clave.html", contexto)


def guarda_clave(request):
	usuario = request.session.get("logueo", False)
	if usuario:
		if request.method == "POST":
			actual = request.POST.get("actual")
			clave1 = request.POST.get("clave1")
			clave2 = request.POST.get("clave2")
			try:
				q = Usuario.objects.get(pk=usuario["id"], passwd=actual)
				if clave1 == clave2:
					q.passwd = clave1
					q.save()
					messages.success(request, "Contraseña actualizada correctamente!!")
				else:
					messages.warning(request, "Nuevas Contraseñas no coinciden...")
			except Exception as e:
				messages.warning(request, f"Contraseña no válida.... {e}")
			return HttpResponseRedirect(reverse("tienda:cambiar_clave", kwargs={'actual': actual}))
	else:
		return HttpResponseRedirect(reverse("tienda:login"))


def ver_perfil(request):
	usuario = request.session.get("logueo", False)
	q = Usuario.objects.get(pk = usuario["id"])
	contexto = {"data": q}
	return render(request, "tienda/usuarios/perfil.html", contexto)


def carrito_agregar(request):
	if request.method == "POST":
		id_producto = request.POST.get("id")
		cantidad = int(request.POST.get("cantidad"))

		if not request.session.get("carrito", False):
			request.session["carrito"] = []

proyectos_django/sena/tienda/templates/tienda/base.html
{% load static %}
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Tienda SENA - {% block titul %}...{% endblock %}</title>

    <link rel="apple-touch-icon" sizes="180x180" href="{% static 'tienda/favicon_io/apple-touch-icon.png' %}">
    <link rel="icon" type="image/png" sizes="32x32" href="{% static 'tienda/favicon_io/favicon-32x32.png' %}">
    <link rel="icon" type="image/png" sizes="16x16" href="{% static 'tienda/favicon_io/favicon-16x16.png' %}">
    <!--<link rel="manifest" href="{% static 'tienda/favicon_io/site.webmanifest' %}">-->

    <link rel="stylesheet" href="{% static 'tienda/css/styles.css' %}" />
    <link rel="stylesheet" href="{% static 'tienda/css/bootstrap.min.css' %}" />
    <link rel="stylesheet" href="{% static 'tienda/icons-main/font/bootstrap-icons.min.css' %}" />
</head>
<body>
    <nav class="navbar navbar-expand-lg" style="background-color: orange;padding-right:0.5rem;">
        <span class="container-fluid">
            <a class="navbar-brand" href="{% url 'tienda:index' 'no' %}">Tienda</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav"
                    aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <span class="collapse navbar-collapse" id="navbarNav">
                <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                    <li class="nav-item">
                        <a class="nav-link active" aria-current="page" href="{% url 'tienda:index' 'no' %}">Inicio</a>
                    </li>
                    {% if request.session.logueo.nombre_rol != "Usuario" %}
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'tienda:listar_categorias' %}">Categorias</a>
                    </li>
                    {% endif %}
                    <li class="nav-item dropdown">
                        <a class="nav-link dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown"
                           aria-expanded="false">
                            Productos
                        </a>
                        <ul class="dropdown-menu">
                            <li><a class="dropdown-item" href="{% url 'tienda:productos' %}">Listar</a></li>
                            <li>
                                <hr class="dropdown-divider">
                            </li>
                            <li><a class="dropdown-item" href="#">Vender</a></li>
                            <li><a class="dropdown-item" href="#">Revisar inventario</a></li>
                        </ul>
                    </li>

                    <li class="nav-item">
                        <a class="nav-link" href="#">Pricing</a>
                    </li>
                    <li class="nav-item">
                        <a href="{% url 'tienda:listar_categorias' %}" class="nav-link {% if request.session.logueo.nombre_rol == 'Usuario' %}disabled{% endif %}" aria-disabled="true">Categorias(Copia)</a>
                    </li>
                    <li class="nav-item dropdown">
                        <a class="nav-link dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown"
                           aria-expanded="false">
                            Reportes
                        </a>
                        <ul class="dropdown-menu">
                            <li><a class="dropdown-item" href="{% url 'tienda:reporte1_ventas' %}">Ventas</a></li>
                        </ul>
                    </li>
                </ul>
                <div class="navbar-text">
                    {% if request.session.logueo %}
                    <ul class="navbar-nav">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown"
                               aria-expanded="false">
                                Bienvenido {{ request.session.logueo.nombre }} ({{ request.session.logueo.nombre_rol }})<!--<img src="{{ request.session.logueo.foto }}">-->
                            </a>
                            <ul class="dropdown-menu">
                                <li><a class="dropdown-item" href="{% url 'tienda:perfil' %}">Perfil</a></li>
                                <li><a class="dropdown-item" href="{% url 'tienda:cambiar_clave' ' ' %}">Cambiar Contraseña</a></li>
                                <li>
                                    <hr class="dropdown-divider">
                                </li>

                                <li><a class="dropdown-item" href="{% url 'tienda:logout' %}">Cerrar sesión</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link position-relative" href="javascript:ver_carrito(`{% url 'tienda:carrito_listar' %}`);">
                                  <i class="bi bi-cart"></i>
                                  <span class="position-absolute top-0 start-100 translate-middle badge rounded-pill bg-danger">
                                    {{ request.session.cantidad_productos|default:0 }}
                                    <span class="visually-hidden">productos</span>
                                  </span>
                            </a>
                        </li>
                    </ul>
                    {% endif %}
                </div>

            </span>
        </span>
    </nav>

    {% if messages %}
        {% for message in messages %}
        <div class="alert alert-{% if message.tags == 'error' %}danger{% else %}{{ message.tags }}{% endif %} alert-dismissible" role="alert">
            <div>{{ message }}</div>
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
        {% endfor %}
    {% endif %}


    <div class="offcanvas offcanvas-end" tabindex="-1" id="offcanvasRight" aria-labelledby="offcanvasRightLabel">
        <div class="offcanvas-header">
            <h5 class="offcanvas-title" id="offcanvasRightLabel">Carrito de Compra ({{ request.session.cantidad_productos|default:0 }})</h5>
            <span id="loading_cc" class="d-none">
                <div class="spinner-border text-primary" role="status">
                    <span class="visually-hidden">Loading...</span>
                </div>
            </span>
            <button type="button" class="btn-close" data-bs-dismiss="offcanvas" aria-label="Close"></button>
        </div>
        <div class="offcanvas-body" id="respuesta_carrito">
            <div class="spinner-border" role="status">
                <span class="visually-hidden">Loading...</span>
            </div>
        </div>
    </div>

    {% block contenedor %}
        ...
    {% endblock %}





    <footer class="fixed-bottom">
        <div class="card card-body">Copyright - Colombia 2023</div>
    </footer>

    <!-- JS include here -->
    <script src="{% static 'tienda/js/bootstrap.bundle.min.js' %}"></script>
    <script src="{% static 'tienda/js/jquery-3.7.1.min.js' %}"></script>
    <script src="{% static 'tienda/js/library.js' %}"></script>
    {% block js_especial %}

    {% endblock %}
    <!-- fin - JS include -->

</body>
</html>

proyectos_django/sena/tienda/templates/tienda/base2.html
{% load static %}
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Tienda SENA - {% block titul %}...{% endblock %}</title>

    <link rel="apple-touch-icon" sizes="180x180" href="{% static 'tienda/favicon_io/apple-touch-icon.png' %}">
    <link rel="icon" type="image/png" sizes="32x32" href="{% static 'tienda/favicon_io/favicon-32x32.png' %}">
    <link rel="icon" type="image/png" sizes="16x16" href="{% static 'tienda/favicon_io/favicon-16x16.png' %}">
    <!--<link rel="manifest" href="{% static 'tienda/favicon_io/site.webmanifest' %}">-->

    <link rel="stylesheet" href="{% static 'tienda/css/styles.css' %}" />
    <link rel="stylesheet" href="{% static 'tienda/css/bootstrap.min.css' %}" />
</head>
<body>


    {% if messages %}
        {% for message in messages %}
        <div class="alert alert-{% if message.tags == 'error' %}danger{% else %}{{ message.tags }}{% endif %} alert-dismissible" role="alert">
            <div>{{ message }}</div>
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
        {% endfor %}
    {% endif %}


    {% block contenedor %}
        ...
    {% endblock %}


    <!-- JS include here -->
    <script src="{% static 'tienda/js/library.js' %}"></script>
    <script src="{% static 'tienda/js/bootstrap.bundle.min.js' %}"></script>

    <!-- fin - JS include -->
</body>
</html>

proyectos_django/sena/tienda/templates/tienda/index.html
{% extends 'tienda/base.html' %}

{% load static %}

{% block titul %} Inicio {% endblock %}

{% block contenedor %}

    <h1>Tienda SENA - ADSO</h1>
    <div class="container text-center mb-5">
        <div class="row align-items-start">
            <div class="col col-3">
                <div class="list-group">
                    <a href="{% url 'tienda:index' 'no' %}?id=0" class="list-group-item list-group-item-action list-group-item-warning {% if request.session.submenu == 0 %}active{% endif %}" aria-current="true">
                        Todos
                    </a>
                    {% for c in categorias %}
                        <a href="{% url 'tienda:index' 'no' %}?id={{ c.id }}" class="list-group-item list-group-item-action list-group-item-warning {% if request.session.submenu == c.id %}active{% endif %}">{{ c.nombre }}</a>
                    {% endfor %}

                </div>
            </div>
            <div class="col col-9">
                <div class="card">
                    <h5 class="card-header">Productos</h5>
                    <div class="card-body">
                        {% for p in productos %}
                            {% if forloop.first %}
                                <div class="row">
                            {% endif %}

                                <div class="card m-2" style="width: 18rem; float:left;">
                                    <img src="{{ p.foto.url }}" class="card-img-top" alt="...">
                                    <div class="card-body">
                                        <h5 class="card-title">{{ p.nombre }} (${{ p.precio }})</h5>
                                        <p class="card-text text-sm text-muted">
                                            <figcaption class="blockquote-footer mt-1">
                                                <cite>Categoría: {{ p.categoria.nombre }}</cite>
                                            </figcaption>
                                        </p>
                                        {% if p.stock <= 0 %}
                                            <strong class="text-danger">Agotado!!</strong>
                                        {% else %}
                                            <form action="{% url 'tienda:carrito_agregar' %}" method="post">
                                                {% csrf_token %}
                                                <input type="hidden" name="id" value="{{ p.id }}">
                                                <input type="number" min="1" max="{{ p.stock }}" value="1" size="3" name="cantidad">
                                                <button type="submit" class="btn btn-primary">Add Carrito</button>
                                            </form>
                                        {% endif %}
                                    </div>
                                </div>

                            {% if forloop.counter|divisibleby:3 %}
                                </div>
                                <div class="row">
                            {% endif %}

                            {% if forloop.last %}
                                </div>
                            {% endif %}


                        {% endfor %}



                    </div>
                </div>
            </div>
        </div>
    </div>

{% endblock %}

proyectos_django/sena/tienda/templates/tienda/login.html
{% extends 'tienda/base2.html' %}

{% load static %}

{% block titul %} Login {% endblock %}

{% block contenedor %}
    <div class="card col-3 mx-auto p-3">
        <div class="card-header">Login Tienda Sena</div>
        <form action="{% url 'tienda:login' %}" method="post" class="card-body">
            {% csrf_token %}
            <input class="form-control" type="text" name="nick" placeholder="Usuario"/><br>
            <input class="form-control" type="password" name="passwd" placeholder="Contraseña"/><br>
            <button type="submit" class="btn btn-info">Enviar</button>
        </form>
    </div>
{% endblock %}

proyectos_django/sena/tienda/templates/tienda/logout.html
Logout